/**
\page mouse_tut_page Tutorial 3

\section input_sec Mouse and Keyboard Input

<b>(NOTE: this section is subject to change - I am not sure about the design of mouse and keyboard handlers yet!)</b>

As it stands the window does not receive mouse and keyboard events. In order to do so we need to attach or 'push' keyboard and mouse handling classes for this window. For very simple applications we allow the DerivedWindow class handle its own mouse input.

First we need to make DerivedWindow inherit from the abstract MouseHandler base class and implement it's interface. Modify the declaration of DerivedWindow as follows:

\code

class DerivedWindow : public GLK::GlWindow, public GLK::MouseHandler
{
...

\endcode

Next define the following functions from the MosueHandler interface:

\code

    // IMPLEMENT THE MOUSE-HANDLER INTERFACE:
    
    void FileDrop( const char* const fileName )
    {
    }

    void DoubleClick( ButtonId id, int x, int y )
    {
    }
    
    void NewPosition( int x, int y )
    {
        m_x = x;
        m_y = GetHeight() - y; // Need to invert mouse y-coord
    }
    
    void ButtonEvent( ButtonId id, bool down )
    {
    }
    
    void Scroll( int delta )
    {
    }
    
    bool WasUpdated()  
    {
    }

    void Activated()  
    {
    }
    
    void Deactivated()
    {
    }

// AND ADD THE FOLLOWING CLASS MEMBERS:
private:
    float m_x;
    float m_y;
    
\endcode

We then need to 'push' the MouseHandler to the window (in this case the window is its own handler but this is not necessary). Modify DerivedWindow's constructor:

\code

    DerivedWindow( GLK::String title ) : GlWindow( 10, 10 )
    {
        GlWindow::SetWindowName( title.cStr() );
        GlWindow::Move( 10,10, 320,240 ); // Move window position to (10,10) and resize window to 320x240 pixels

        // ADD THIS LINE
        PushMouseHandler( this );
    };

\endcode

Finally lets translate the text so that it is rendered at the mouse co-ordinates. Modify the glTranslate call in Render():

\code
    
    glTranslatef( m_x, m_y, 0 );
    
\endcode

Compile and run the program. The text should now follow the mouse cursor.

\ref alpha_tut_page

*/
