/**

\page ack_page Acknowledgements/Requirements
 
This software makes use of the following libraries which must be downloaded and installed separately:

\section lua_sec Lua
http://www.lua.org/ (tested with version 5.1.4)

Copyright © 1994–2008 Lua.org, PUC-Rio.
 
Lua is used under the MIT license.

@n
\section ft_sec FreeType
http://www.freetype.org (tested with version 2.3.11)

The FreeType Project is copyright © 1996-2000  by David Turner, Robert Wilhelm, and Werner Lemberg.

FreeType is used under the 'FreeType license'.

@n
\section gtest_sec Googletest
http://code.google.com/p/googletest/ (version 1.4)

This is required if you want to compile and run the unit tests.
<b>NOTE:</b> On win32 you need to rebuild 'gtest.lib', linking it against the 'Multi-Threaded DLL'
runtime libraries which is not the default in the google-test visual studio project.

Googletest is available under the New BSD license. Copyright 2008, Google Inc. All rights reserved.

@n
\section premake_sec Premake4

The build system requires Premake 4.2
http://industriousone.com/premake @n

@n
\section win_specific Windows Specific Requirements:

\subsection pthread_sec Pthreads-Win32
http://sourceware.org/pthreads-win32/ (version 2.8)@n

Required for Windows versions only. In future it is intended that the native thread
library will be used on Windows versions later than XP.

Pthreads-Win32 is licensed under the LGPL (so should not be statically linked).

@n
\section linux_specific Linux Specific Requirements

You need the Xorg X11 development libraries and you also
need the XRender libraries for desktop composition effects
which are part of GLK as standard. Your Linux distribution's
software management system should allow you to install these easily.
E.g. see Ubuntu instructions below.

\subsection ubuntu_sec Building on Ubuntu 10.xx

From a fresh install of Ubuntu 10.04 the following gets you most of the way to being able to build GLK:
\code
sudo apt-get install libx11-dev
sudo apt-get install libxrender-dev
sudo apt-get install lua5.1
sudo apt-get install liblua5.1-dev
sudo apt-get install libgtest0
\endcode

That just leaves freetype2 and premake to be installed.

On other Linux distributions you will have to find out which packages import the same libraries,
or install the libraries manually from the links above.

*/

