// Copyright (c) Mark Pupilli 2010, All Rights Reserved.

#ifndef DERIVED_WINDOW_H
#define DERIVED_WINDOW_H

#include <glkcore.h>
#include <glk.h>

class DerivedWindow : public GLK::GlWindow
{
public:
    DerivedWindow( GLK::String title ) : GlWindow( 10, 10 )
    {
        GlWindow::SetWindowName( title.cStr() );
        GlWindow::Move( 10,10, 320,240 ); // Move window position to (10,10) and resize window to 320x240 pixels
    };

    virtual ~DerivedWindow()
    {
    };

    virtual bool InitGL()
    {
        glClearColor( 1.f, 1.f, 1.f, 1.f );
        
        // Perform other initialisation here...
            
        return true; // Must indicate whether initialisation was successful or not.
    };

    virtual void DestroyGL()
    {
    };

    virtual void Resize( unsigned int width, unsigned int height )
    {
        // Window has been resized so perform necessary updates...
    };

    virtual bool Update( unsigned int time_ms )
    {
        return true; // Render() only gets called if Update() returns true.
    };

    virtual void Render()
    {
        // Would perform rendering here ...

        SwapBuffers();

        glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    };

    virtual void TimerExpired( int timerId ) {};

private:

};

#endif // DERIVED_WINDOW_H


