// Copyright (c) Mark Pupilli 2010, All Rights Reserved.

#include <stdio.h>

#include <glkcore.h>
#include <glk.h>

#include "DerivedWindowModified.h"

using namespace GLK;

int main( int argc, char** argv )
{
    GlConfig glConfig;
    glConfig.SetStencilSize(8); // default stencil is 0 - we don't need stencil here but just for testing.
    DerivedWindow win( String( "Hello World" ), glConfig ); // Create window object, passing the window title into the constructor

    const GlConfig& config = win.GetGlConfig();
    printf( "Framebuffer info:\n\tRGBA %d%d%d%d, DEPTH %d-bit STENCIL %d-bit, double-buffered = %d\n",
            config.GetRedSize(),
            config.GetGreenSize(),
            config.GetBlueSize(),
            config.GetAlphaSize(),
            config.GetDepthSize(),
            config.GetStencilSize(), // we changed this from default so it should be set to 8-bit if its supported
            config.IsDoubleBuffered()
           );

    win.Show(); // Make the window visible
    int exitCode = win.StartEventLoop(); // Enter the window's event loop

    return exitCode;
}

