-- Example of using GLK with Lua as a 'stand-alone' language.
--
-- This creates the same window as in lua-window.lua but no C++ program
-- is required - The LuaGLK dynamic library is loaded directly from lua.
--
-- You need LuaGL installed for the following script to work: http://luagl.sourceforge.net/

require( "luaglk" )

lua_window = glk.NewWindow( 'LuaGLK Test', 320, 240 )

print( lua_window )

if ( lua_window == nil ) then
    print 'glk.NewWindow() failed.'
    return
end

-- Dirty hack using debug system to get the path to this file:
path = debug.getinfo( 1, "S" ).source:match[[^@?(.*[\/])[^\/]-$]]

if ( path ) then
    -- Path is not nil so use it to load file which I know is in same directory:
    dofile ( path  .. 'lua-window.lua' )
else
    dofile 'lua-window.lua'
end

-- Start the window's event loop:
lua_window.Start();

-- Event loop runs in separate thread so wait for it to close:
lua_window.WaitForClose();
glk.DeleteWindow( 'LuaGLK Test' )

