#ifndef BASIC_KEYBOARD_H
#define BASIC_KEYBOARD_H

#include "../include/glkcore.h"
#include "KeyboardHandler.h"

namespace GLK
{

class FW_API BasicKeyboard : public KeyboardHandler
{

public:
    BasicKeyboard() : m_active(false), m_lastChar(0), m_updated(false) {};
    virtual ~BasicKeyboard() {}; 

    void Key( char c )
    {
        m_lastChar = c;
        m_updated = true;
    };

    char GetLastChar() { char tmp = m_lastChar; m_lastChar=0; return tmp; };

    void Activated() { m_active=true; };
    void Deactivated() { m_active=false; };

    //! Return true if the handler was updated since the last call to WasUpdated().
    bool WasUpdated() { bool tmp = m_updated; m_updated = false; return tmp; };

protected:

private:
    bool m_active;
    char m_lastChar;
    bool m_updated;
};


} // end namespace GLK

#endif // BASIC_KEYBOARD_H
