#ifndef CONSOLE_H
#define CONSOLE_H

#include "../include/glkcore.h"
#include "KeyboardHandler.h"

namespace GLK
{

/**
    A very basic console and the base class for more complex ones.

    This simple console keeps a history of commands that were typed into it.
**/
class Console : public KeyboardHandler
{

public:
    Console( unsigned int commandLength, unsigned int historyLength );
    virtual ~Console();

    virtual bool Type( const char* pChars, unsigned int numChars );
    virtual void Retrieve( String& dest, unsigned int historyIndex );
    
    virtual void Key( char c ) { Type( &c, 1); };
    bool WasUpdated()    { bool tmp = m_updated; m_updated=false; return tmp; };

    virtual void Activated() {};
    virtual void Deactivated() {};

protected:
    void Updated() { m_updated=true; };

    String m_command;
    CircularBuffer<String> m_history;

private:
    SET_UNCOPYABLE( Console )
    bool m_updated;
};

} // end namespace GLK

#endif // CONSOLE_H

