#ifndef LUA_CONSOLE_H
#define LUA_CONSOLE_H

#include "../glkcore/fwconfig.h"

#include "Console.h"
#include "../glkcore/lua/LuaSupport.h"

namespace GLK
{

class FW_API LuaConsole : public Console
{
public:
    LuaConsole( unsigned int commandLength, unsigned int historyLength );
    virtual ~LuaConsole();

    bool Type( const char* pChars, unsigned int numChars );

    void Key( char c );
    void Activated()     { m_active = true; };
    void Deactivated()   { m_active = false; };
    
    Lua::LuaState* GetLua() { return &m_lua; };

protected:

private:
    SET_UNCOPYABLE( LuaConsole )
    
    Lua::LuaState m_lua;
    bool m_active;
};

}// end namespace GLK

#endif // LUA_CONSOLE_H

