#ifndef WINDOW_TYPES_H
#define WINDOW_TYPES_H

namespace GLK
{

/**
    Window type gives a small amount of control over window properties.
**/
enum WindowFlags
{
    Normal          = 0x0, // Ddefault window (depends on platform and window manager).
    Slim            = 0x1, // Results in a normal window on linux, a window with slim borders on win32
    FullScreen      = 0x2, // Currently ignored by all implementations!
    AlphaComposited = 0x4, // Results in a normal window on win32, a window that can be alpha composited by the window manager on linux.
    Async           = 0x8, // Window is setup so that it's event loop runs in  a separate thread.
    Decorless       = 0x10 // Window will not have a border or title bar (if the window manager supports/allows this)
};

} // end namespace GLK

#endif // WINDOW_TYPES_H

