#include "../GlFramework.h"

#ifdef WIN32

static bool IsWhiteSpace( char c )
{
    switch(c)
    {
    case '\b':
    case '\t':
    case '\n':
    case '\v':
    case '\f':
    case '\r':
    case ' ':
    case '\0':
        return true;
        
    default:
        return false;
    }
}

/**
    Statndard windows entry point.

    This function simply calls 'main'
    (redefined as fwMain in GlFramework.h)

    Using this technique programs will appear to have a standard
    'main' entry point on all platforms.
**/
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR args, int )
{
    int exitVal;

#ifdef USE_WIN32_CONSOLE
    AllocConsole(); // for debugging create a console (Windows releases consoles automatically)
#endif

    // Pass traditional argc and argv arguments to main
    size_t l = strlen( args );
    int argc = 0;
    
    char* p = args;
    char* const end = args + l + 1;
    while ( p++ != end )
    {
        if ( IsWhiteSpace(*p) && !IsWhiteSpace( *(p-1) ) )
        {
            *p = '\0';
            argc++;
        }
    }
    
    char** argv = 0;
    if ( argc )
    {
        argv = new char*[argc];

        p = args;
        argv[0] = p;
        int i = 1;
        
        while ( p++ != (end-2) ) // end-2 because we don't want to confuse final '\0' for start of next arg.
        {
            if ( *p == '\0' )
            {
                argv[i++] = p+1;
                assert( i <= argc );
            }
        }
    }

    exitVal = fwMain( argc, argv );
    
    delete [] argv;
    
    return exitVal;
}

#endif
