#ifndef KEY_ENUMS_H
#define KEY_ENUMS_H

#define WIN32_MEAN_AND_LEAN
#include <windows.h>

namespace GLK
{

/**
    Enum describing keyboard
    in standard framewrok format.
**/
typedef enum {
    KeyVoid = 0,
    KeyBackSpace    = VK_BACK,
    KeyTab          = VK_TAB,
    KeyClear        = VK_CLEAR,
    KeyReturn       = VK_RETURN,
    KeyPause        = VK_PAUSE,
    KeyScrollLock   = VK_SCROLL,
    KeySysRq,
    KeyEscape       = VK_ESCAPE,
    KeyDelete       = VK_DELETE,
    KeyHome         = VK_HOME,
    KeyLeft         = VK_LEFT,
    KeyUp           = VK_UP,
    KeyRight        = VK_RIGHT,
    KeyDown         = VK_DOWN,
    KeyPageUp       = SB_PAGEUP,
    KeyPageDown     = SB_PAGEDOWN,
    KeyEnd          = VK_END,
    KeyPrint        = VK_PRINT,
    KeyInsert       = VK_INSERT,
    KeyUndo,
    KeyRedo,
    KeyHelp         = VK_HELP,
    KeyBreak,
    KeyNumLock      = VK_NUMLOCK,
    KeyKpSpace,
    KeyKpTab,
    KeyKpEnter,
    KeyKpHome,
    KeyKpLeft,
    KeyKpUp,
    KeyKpRight,
    KeyKpDown,
    KeyKpPageUp,
    KeyKpPageDown,
    KeyKpEnd,
    KeyKpInsert,
    KeyKpDelete,
    KeyKpEqual  = VK_OEM_NEC_EQUAL,
    KeyKpMult   = VK_MULTIPLY,
    KeyKpAdd    = VK_ADD,
    KeyKpSub    = VK_SUBTRACT,
    KeyKpDecimal= VK_DECIMAL,
    KeyKpDiv    = VK_DIVIDE,
    KeyKp0      = VK_NUMPAD0, 
    KeyKp1      = VK_NUMPAD1,
    KeyKp2      = VK_NUMPAD2,
    KeyKp3      = VK_NUMPAD3,
    KeyKp4      = VK_NUMPAD4,
    KeyKp5      = VK_NUMPAD5,
    KeyKp6      = VK_NUMPAD6,
    KeyKp7      = VK_NUMPAD7,
    KeyKp8      = VK_NUMPAD8,
    KeyKp9      = VK_NUMPAD9,
    KeyF1       = VK_F1,
    KeyF2       = VK_F2,
    KeyF3       = VK_F3,
    KeyF4       = VK_F4,
    KeyF5       = VK_F5,
    KeyF6       = VK_F6,
    KeyF7       = VK_F7,
    KeyF8       = VK_F8,
    KeyF9       = VK_F9,
    KeyF10      = VK_F10,
    KeyF11      = VK_F11,
    KeyF12      = VK_F12,
    KeyF13      = VK_F13,
    KeyF14      = VK_F14,
    KeyF15      = VK_F15,
    KeyF16      = VK_F16,
    KeyF17      = VK_F17,
    KeyF18      = VK_F18,
    KeyF19      = VK_F19,
    KeyF20      = VK_F20,
    KeyLeftShift    = VK_LSHIFT,
    KeyRightShift   = VK_RSHIFT,
    KeyLeftControl  = VK_LCONTROL,
    KeyRightControl = VK_RCONTROL,
    KeyCapsLock     = VK_CAPITAL,
    KeyShiftLock    = VK_SHIFT,
    KeyLeftAlt      = VK_LMENU,
    KeyRightAlt     = VK_RMENU,
    KeyLeftSuper    = VK_LWIN,
    KeyRightSuper   = VK_RWIN,
    KeySpace        = ' ',
    KeyExclam       = '!',
    KeyDblQuote     = '"',
    KeyNumber       = '#',
    KeyDollar       = '$',
    KeyPercent      = '%',
    KeyAmpersand    = '&',
    KeyApostrophe   = '\'',
    KeyLeftParen    = '(',
    KeyRightParen   = ')',
    KeyAsterisk = '*',
    KeyPlus     = '+',
    KeyComma    = ',',
    KeyMinus    = '-',
    KeyPeriod   = '.',
    KeySlash    = '/',
    Key0    = '0',
    Key1    = '1',
    Key2    = '2',
    Key3    = '3',
    Key4    = '4',
    Key5    = '5',
    Key6    = '6',
    Key7    = '7',
    Key8    = '8',
    Key9    = '9',
    KeyColon        = ':',
    KeySemiColon    = ';',
    KeyLess         = '<',
    KeyEqual        = '=', 
    KeyGreater      = '>',
    KeyQuestion     = '?',
    KeyAt           = '@',
    KeyA    = 'A',
    KeyB,
    KeyC,
    KeyD,
    KeyE,
    KeyF,
    KeyG,
    KeyH,
    KeyI,
    KeyJ,
    KeyK,
    KeyL,
    KeyM,
    KeyN,
    KeyO,
    KeyP,
    KeyQ,
    KeyR,
    KeyS,
    KeyT,
    KeyU,
    KeyV,
    KeyW,
    KeyX,
    KeyY,
    KeyZ    = 'Z',
    KeyLeftBracket  = '{',
    KeyBackSlash    = '\\',
    KeyRightBracket = '}',
    KeyASciiCirc,
    KeyUnderScore   = '_',
    KeyGrave,
    Keya    =   'A',
    Keyb,
    Keyc,
    Keyd,
    Keye,
    Keyf,
    Keyg,
    Keyh,
    Keyi,
    Keyj,
    Keyk,
    Keyl,
    Keym,
    Keyn,
    Keyo,
    Keyp,
    Keyq,
    Keyr,
    Keys,
    Keyt,
    Keyu,
    Keyv,
    Keyw,
    Keyx,
    Keyy,
    Keyz    = 'Z',
    KeyLeftBrace = '[',
    KeyBar       = '|',
    KeyRightBrace= ']',
    KeyTilde     = '~',
    KeySterling  = '',
    NumKeys
} Key;

}

#endif
