#include "XKeyboard.h"

GLK::Key ConvertXKeySym(KeySym k)
{
  switch (k)
  {
  case XK_VoidSymbol:   return GLK::KeyVoid;
  case XK_BackSpace:    return GLK::KeyBackSpace;
  case XK_Tab:          return GLK::KeyTab;
  case XK_Clear:        return GLK::KeyClear;
  case XK_Return:       return GLK::KeyReturn;
  case XK_Pause:        return GLK::KeyPause;
  case XK_Scroll_Lock:  return GLK::KeyScrollLock;
  case XK_Sys_Req:      return GLK::KeySysRq;
  case XK_Escape:       return GLK::KeyEscape;
  case XK_Delete:       return GLK::KeyDelete;

  case XK_Home:         return GLK::KeyHome;
  case XK_Left:         return GLK::KeyLeft;
  case XK_Up:           return GLK::KeyUp;
  case XK_Right:        return GLK::KeyRight;
  case XK_Down:         return GLK::KeyDown;
    //case XK_Prior:	 return GLK::KeyPrior;
  case XK_Page_Up:      return GLK::KeyPageUp;
    //case XK_Next:	 return GLK::Key;
  case XK_Page_Down:    return GLK::KeyPageDown;
  case XK_End:          return GLK::KeyEnd;
    //case XK_Begin:	 return GLK::KeyBegin;
    //case XK_Select:	 return GLK::KeySelect;
  case XK_Print:        return GLK::KeyPrint;
    //case XK_Execute:	 return GLK::KeyExecute;
  case XK_Insert:       return GLK::KeyInsert;
  case XK_Undo:         return GLK::KeyUndo;
  case XK_Redo:         return GLK::KeyRedo;
    //case XK_Menu:	 return GLK::KeyMenu;
    //case XK_Find:	 return GLK::KeyFind;
    //case XK_Cancel:	 return GLK::KeyCancel;
  case XK_Help:         return GLK::KeyHelp;
  case XK_Break:        return GLK::KeyBreak;
    //case XK_Mode_switch:	 return GLK::Key;
    //case XK_script_switch:	 return GLK::Key;
  case XK_Num_Lock:     return GLK::KeyNumLock;
  case XK_KP_Space:     return GLK::KeyKpSpace;
  case XK_KP_Tab:       return GLK::KeyKpTab;
  case XK_KP_Enter:     return GLK::KeyKpEnter;
    //case XK_KP_F1:	 return GLK::Key;
    //case XK_KP_F2:	 return GLK::Key;
    //case XK_KP_F3:	 return GLK::Key;
    //case XK_KP_F4:	 return GLK::Key;
    case XK_KP_Home:    return GLK::KeyKpHome;
  case XK_KP_Left:      return GLK::KeyKpLeft;
  case XK_KP_Up:        return GLK::KeyKpUp;
  case XK_KP_Right:     return GLK::KeyKpRight;
  case XK_KP_Down:      return GLK::KeyKpDown;
    //case XK_KP_Prior:	 return GLK::KeyKpPrior;
  case XK_KP_Page_Up:   return GLK::KeyKpPageUp;
    //case XK_KP_Next:	 return GLK::KeyKpNext;
  case XK_KP_Page_Down: return GLK::KeyKpPageDown;
  case XK_KP_End:       return GLK::KeyKpEnd;
    //case XK_KP_Begin:	 return GLK::KeyKpBegin;
  case XK_KP_Insert:	 return GLK::KeyKpInsert;
  case XK_KP_Delete:	 return GLK::KeyKpDelete;
  case XK_KP_Equal:	 return GLK::KeyKpEqual;
  case XK_KP_Multiply:	 return GLK::KeyKpMult;
  case XK_KP_Add:	 return GLK::KeyKpAdd;
    //case XK_KP_Separator:	 return GLK::KeyKp;
  case XK_KP_Subtract:	 return GLK::KeyKpSub;
  case XK_KP_Decimal:	 return GLK::KeyKpDecimal;
  case XK_KP_Divide:	 return GLK::KeyKpDiv;
  case XK_KP_0:	 return GLK::KeyKp0;
  case XK_KP_1:	 return GLK::KeyKp1;
  case XK_KP_2:	 return GLK::KeyKp2;
  case XK_KP_3:	 return GLK::KeyKp3;
  case XK_KP_4:	 return GLK::KeyKp4;
  case XK_KP_5:	 return GLK::KeyKp5;
  case XK_KP_6:	 return GLK::KeyKp6;
  case XK_KP_7:	 return GLK::KeyKp7;
  case XK_KP_8:	 return GLK::KeyKp8;
  case XK_KP_9:	 return GLK::KeyKp9;
  case XK_F1:	 return GLK::KeyF1;
  case XK_F2:	 return GLK::KeyF2;
  case XK_F3:	 return GLK::KeyF3;
  case XK_F4:	 return GLK::KeyF4;
  case XK_F5:	 return GLK::KeyF5;
  case XK_F6:	 return GLK::KeyF6;
  case XK_F7:	 return GLK::KeyF7;
  case XK_F8:	 return GLK::KeyF8;
  case XK_F9:	 return GLK::KeyF9;
  case XK_F10:	 return GLK::KeyF10;
  case XK_F11:	 return GLK::KeyF11;
    //case XK_L1:	 return GLK::KeyL1;
  case XK_F12:	 return GLK::KeyF12;
    //case XK_L2:	 return GLK::KeyL2;
  case XK_F13:	 return GLK::KeyF13;
    //case XK_L3:	 return GLK::KeyL3;
  case XK_F14:	 return GLK::KeyF14;
    //case XK_L4:	 return GLK::KeyL4;
  case XK_F15:	 return GLK::KeyF15;
    //case XK_L5:	 return GLK::KeyL5;
  case XK_F16:	 return GLK::KeyF16;
    //case XK_L6:	 return GLK::KeyL6;
  case XK_F17:	 return GLK::KeyF17;
    //case XK_L7:	 return GLK::KeyL7;
  case XK_F18:	 return GLK::KeyF18;
    //case XK_L8:	 return GLK::KeyL8;
  case XK_F19:	 return GLK::KeyF19;
    //case XK_L9:	 return GLK::KeyL9;
  case XK_F20:	 return GLK::KeyF20;

  case XK_Shift_L:	 return GLK::KeyLeftShift;
  case XK_Shift_R:	 return GLK::KeyRightShift;
  case XK_Control_L:	 return GLK::KeyLeftControl;
  case XK_Control_R:	 return GLK::KeyRightControl;
  case XK_Caps_Lock:	 return GLK::KeyCapsLock;
  case XK_Shift_Lock:	 return GLK::KeyShiftLock;
						 //case XK_Meta_L:	 return GLK::Key;
						 //  case XK_Meta_R:	 return GLK::Key;
  case XK_Alt_L:	 return GLK::KeyLeftAlt;
  case XK_Alt_R:	 return GLK::KeyRightAlt;
  case XK_Super_L:	 return GLK::KeyLeftSuper;
  case XK_Super_R:	 return GLK::KeyRightSuper;

  case XK_space:	 return GLK::KeySpace;
  case XK_exclam:	 return GLK::KeyExclam;
  case XK_quotedbl:	 return GLK::KeyDblQuote;
  case XK_numbersign:	 return GLK::KeyNumber;
  case XK_dollar:	 return GLK::KeyDollar;
  case XK_percent:	 return GLK::KeyPercent;
  case XK_ampersand:	 return GLK::KeyAmpersand;
  case XK_apostrophe:	 return GLK::KeyApostrophe;
    //case XK_quoteright:	 return GLK::KeyRightQuote;
  case XK_parenleft:	 return GLK::KeyLeftParen;
  case XK_parenright:	 return GLK::KeyRightParen;
  case XK_asterisk:	 return GLK::KeyAsterisk;
  case XK_plus:	 return GLK::KeyPlus;
  case XK_comma:	 return GLK::KeyComma;
  case XK_minus:	 return GLK::KeyMinus;
  case XK_period:	 return GLK::KeyPeriod;
  case XK_slash:	 return GLK::KeySlash;
  case XK_0:	 return GLK::Key0;
  case XK_1:	 return GLK::Key1;
  case XK_2:	 return GLK::Key2;
  case XK_3:	 return GLK::Key3;
  case XK_4:	 return GLK::Key4;
  case XK_5:	 return GLK::Key5;
  case XK_6:	 return GLK::Key6;
  case XK_7:	 return GLK::Key7;
  case XK_8:	 return GLK::Key8;
  case XK_9:	 return GLK::Key9;
  case XK_colon:	 return GLK::KeyColon;
  case XK_semicolon:	 return GLK::KeySemiColon;
  case XK_less:	 return GLK::KeyLess;
  case XK_equal:	 return GLK::KeyEqual;
  case XK_greater:	 return GLK::KeyGreater;
  case XK_question:	 return GLK::KeyQuestion;
  case XK_at:	 return GLK::KeyAt;
  case XK_A:	 return GLK::KeyA;
  case XK_B:	 return GLK::KeyB;
  case XK_C:	 return GLK::KeyC;
  case XK_D:	 return GLK::KeyD;
  case XK_E:	 return GLK::KeyE;
  case XK_F:	 return GLK::KeyF;
  case XK_G:	 return GLK::KeyG;
  case XK_H:	 return GLK::KeyH;
  case XK_I:	 return GLK::KeyI;
  case XK_J:	 return GLK::KeyJ;
  case XK_K:	 return GLK::KeyK;
  case XK_L:	 return GLK::KeyL;
  case XK_M:	 return GLK::KeyM;
  case XK_N:	 return GLK::KeyN;
  case XK_O:	 return GLK::KeyO;
  case XK_P:	 return GLK::KeyP;
  case XK_Q:	 return GLK::KeyQ;
  case XK_R:	 return GLK::KeyR;
  case XK_S:	 return GLK::KeyS;
  case XK_T:	 return GLK::KeyT;
  case XK_U:	 return GLK::KeyU;
  case XK_V:	 return GLK::KeyV;
  case XK_W:	 return GLK::KeyW;
  case XK_X:	 return GLK::KeyX;
  case XK_Y:	 return GLK::KeyY;
  case XK_Z:	 return GLK::KeyZ;
  case XK_bracketleft:	 return GLK::KeyLeftBracket;
  case XK_backslash:	 return GLK::KeyBackSlash;
  case XK_bracketright:	 return GLK::KeyRightBracket;
  case XK_asciicircum:	 return GLK::KeyASciiCirc;
  case XK_underscore:	 return GLK::KeyUnderScore;
  case XK_grave:	 return GLK::KeyGrave;
    //  case XK_quoteleft:	 return GLK::KeyLeftQuote;
  case XK_a:	 return GLK::Keya;
  case XK_b:	 return GLK::Keyb;
  case XK_c:	 return GLK::Keyc;
  case XK_d:	 return GLK::Keyd;
  case XK_e:	 return GLK::Keye;
  case XK_f:	 return GLK::Keyf;
  case XK_g:	 return GLK::Keyg;
  case XK_h:	 return GLK::Keyh;
  case XK_i:	 return GLK::Keyi;
  case XK_j:	 return GLK::Keyj;
  case XK_k:	 return GLK::Keyk;
  case XK_l:	 return GLK::Keyl;
  case XK_m:	 return GLK::Keym;
  case XK_n:	 return GLK::Keyn;
  case XK_o:	 return GLK::Keyo;
  case XK_p:	 return GLK::Keyp;
  case XK_q:	 return GLK::Keyq;
  case XK_r:	 return GLK::Keyr;
  case XK_s:	 return GLK::Keys;
  case XK_t:	 return GLK::Keyt;
  case XK_u:	 return GLK::Keyu;
  case XK_v:	 return GLK::Keyv;
  case XK_w:	 return GLK::Keyw;
  case XK_x:	 return GLK::Keyx;
  case XK_y:	 return GLK::Keyy;
  case XK_z:	 return GLK::Keyz;
  case XK_braceleft:	 return GLK::KeyLeftBrace;
  case XK_bar:	         return GLK::KeyBar;
  case XK_braceright:	 return GLK::KeyRightBrace;
  case XK_asciitilde:	 return GLK::KeyTilde;
    //case XK_nobreakspace:	 return GLK::Key;
    //case XK_exclamdown:	 return GLK::Key;
    //case XK_cent:	 return GLK::KeyCent;
  case XK_sterling:	 return GLK::KeySterling;
  }

  return GLK::KeyVoid;
}
