#ifndef FreeType_LIBRARY_H
#define FreeType_LIBRARY_H

#include "../fwconfig.h"

extern "C"
{
#include <ft2build.h>
#include FT_FREETYPE_H
}

#include "../utility/GlobalDefs.h"

namespace Ft
{

/**
    Wrapper for a handle to FreeType2 FT_Library handle.
**/
class FW_API Library
{
friend class Face;

public:
    Library();
    ~Library();

    FT_Error GetError() const { return m_err; };

protected:

private:
    SET_UNCOPYABLE( Library )

    FT_Library m_lib;
    FT_Error m_err;

};

} // end namespace Ft

#endif // FreeType_LIBRARY_H
