#ifndef FW_CONFIG_H
#define FW_CONFIG_H

// Win-32 specific:
// By default it will be assumed you are building an application which is dynamically linked
// to the Fw library dlls. (The following preprocessor commands drop through in such a way that
// FW_API is __declspec(dllimport).
//
// If you want to build the DLLS then BUILDING_FW_DLLS should be defined.
// If you want to build an application which links to the static Fw libraries then you need to define FW_STATIC.
// Do not define both BUILDING_FW_DLLS and FW_STATIC as BUILDING_FW_DLLS will take precedence!

#ifdef WIN32

#ifdef BUILDING_FW_DLLS
#define FW_API  __declspec(dllexport)
#elif FW_STATIC
#define FW_API 
#else
#define FW_API __declspec(dllimport)
#endif

#else
#define FW_API
#endif

#endif  // FW_CONFIG_H
