#ifndef GLK_STD_IN_CLASS_H
#define GLK_STD_IN_CLASS_H

#include "../fwconfig.h"

#include <stdlib.h>

namespace GLK
{
    
/**
    Abstract class defining a standard inpput
    interface for classes to derive from. The
    interface is designed to mimic stdio from C.

    The interface is minimal - some classes only
    require a simple read/write interface without
    all the other complexity usually associated
    with streams (e.g flushing, re-positioning etc.)
    It is desirable that such classes be comaptible
    with more complex IO classes.
**/
class FW_API StdIn
{
public:
    StdIn() {};
    virtual ~StdIn() {};

    //! Formatted scan/read
    //! @return The number of fields successfully converted.
    virtual int Scanf( const char* formatString, ... ) = 0;

    //! Read a specified number of bytes into a buffer
    //! @return The actual number of bytes written.
    virtual size_t Read( char* buffer, size_t numBytes ) = 0;
};

} // end namepsace GLK

#endif // GLK_STD_IN_CLASS_H

