#ifndef GLK_SEMAPHORE_H
#define GLK_SEMAPHORE_H

#include <assert.h>

#include "Mutex.h"
#include "ConditionVariable.h"

#include "../utility/GlobalDefs.h"

namespace GLK
{

/**
	Implements the semaphore primitive: an up/down semaphore constructed from a mutex and a condition variable.
**/
class FW_API Semaphore
{
public:
    static void Test();

	Semaphore( int count );
	~Semaphore();

	void Acquire( int n = 1 );
	bool TryAcquire( int n = 1 );
	void Release( int n = 1 );

private:
	SET_UNCOPYABLE(Semaphore);

	Mutex m_lock;
	ConditionVariable m_cond;
	int m_count;
    int m_required;
};

} // End namespace GLK

#endif // GLK_SEMAPHORE_H
