#ifndef GLK_STRING_H
#define GLK_STRING_H

#include "../fwconfig.h"

#include <stdio.h>

namespace GLK
{

/**
	A very simple string class.
**/
class FW_API String
{
public:
	explicit String( unsigned int l = 0 );
	explicit String( const char*, unsigned int l=0 );
	String( const String& );
	~String();

	//! Return true if the string contains no characters.
	bool IsEmpty() const { return m_size==0; };

	//!< number of characters in string (excluding terminator).
	size_t Size() const { return m_size; };

	void Print( FILE* fp = stdout );

		  char* cStr()		 { return m_pData; };
	const char* cStr() const { return m_pData; };

	//!< Make the string empty without affecting capacity.
	void Clear() { m_size = 0; };

	void SubString( String& s, size_t start, size_t end );

    void Insert( const String& s, unsigned int i );
    void Insert( char c, unsigned int i );
    void Delete( unsigned int i );

    void Trim( String& trimmedString );

	String& operator = ( const String& );
	String& operator += ( const String& );
	String& operator += ( char );
    
    bool operator == ( const String& ) const;
    bool operator != ( const String& ) const;

		  char&   operator [] ( unsigned int i )	   { return m_pData[i]; };
	const char&   operator [] ( unsigned int i ) const { return m_pData[i]; };

    static void Test();

protected:

private:
	char*		 m_pData;
	size_t       m_capacity;
	size_t       m_size; // Size of string excluding the null terminating character
};

} // END namespace GLK

#endif // GLK_STRING_H
