#include "../include/glkcore.h"

namespace GLK
{

class TestThread : public Thread
{
public:
    TestThread() : m_ran( false ) {};
    ~TestThread() {};
    bool WasRun() const { return m_ran; };

    void Run()
    {
        m_ran = true;
    };

private:
    bool m_ran;

};

class TestBarrier : public Thread
{
public:
    TestBarrier( Barrier& b ) : m_b(b), m_past(false) {};
    ~TestBarrier() {};

    void Run()
    {
        m_b.Wait();
        m_past = true;
    };

    bool PastBarrier() const { return m_past; };

private:
    Barrier& m_b;
    bool m_past;
};

} // end of namespace GLK

